DECLARE SUB PrintFlds ()
DECLARE SUB TitleCase (Text$)
DECLARE SUB Strip (Text$)
DECLARE SUB MoreStrip (Text$)

'PreMatch.bas   Ray Thomas      August 2000

'*** A program to get text into a form suitable for matching
'*** To simplfy the program I will assume no spaces between hyphenated surnames
'*** It will also contain a "contact" field and a salutation

TYPE InRec
        Title AS STRING * 5
        Initial AS STRING * 5
        Surname AS STRING * 20
        Fullname AS STRING * 20
        Add1 AS STRING * 20
        Add2 AS STRING * 20
        Add3 AS STRING * 20
        Salut AS STRING * 30
        Contact AS STRING * 30
        MName AS STRING * 20
        MAdd1 AS STRING * 20
        MAdd2 AS STRING * 20
        MAdd3 AS STRING * 20
END TYPE

DIM SHARED Record(9) AS InRec   'An array to hold the records
DIM TitleComp(6) AS STRING      'Array to compare titles
DIM Counter AS INTEGER          'A counter for loop counts
DIM Count AS INTEGER            'A counter for loop counts
DIM Number AS INTEGER           'General numeric variable

'*** When defining type arrays they are initialised to NULLS
'*** to make text comparisons easier we are going to fill them with spaces

FOR Counter = 1 TO UBOUND(Record) - 1
        Record(Counter).Title = SPACE$(LEN(Record(Counter).Title))
        Record(Counter).Initial = SPACE$(LEN(Record(Counter).Initial))
        Record(Counter).Surname = SPACE$(LEN(Record(Counter).Surname))
        Record(Counter).Fullname = SPACE$(LEN(Record(Counter).Fullname))
        Record(Counter).Add1 = SPACE$(LEN(Record(Counter).Add1))
        Record(Counter).Add2 = SPACE$(LEN(Record(Counter).Add2))
        Record(Counter).Add3 = SPACE$(LEN(Record(Counter).Add3))
        Record(Counter).Salut = SPACE$(LEN(Record(Counter).Salut))
        Record(Counter).Contact = SPACE$(LEN(Record(Counter).Contact))
        Record(Counter).MName = SPACE$(LEN(Record(Counter).MName))
        Record(Counter).MAdd1 = SPACE$(LEN(Record(Counter).MAdd1))
        Record(Counter).MAdd2 = SPACE$(LEN(Record(Counter).MAdd2))
        Record(Counter).MAdd3 = SPACE$(LEN(Record(Counter).MAdd3))
NEXT Counter

'***  Define some records  ***
DATA Mr A B Sample,123 Sample Road,Sample Town,Sample County
DATA Mr A Sample,"123, Sample Road",SampleTown,SampleCounty
DATA MR A SAMPLE,123 SAMPLE ROAD,SAMPLE TOWN,SAMPLE COUNTY
DATA Mr Alan Sample,123 Sample Rd,Sample Town,Sample County
DATA Alan Sample,"123, Sample Rd",SAmple Town,Sample CouNty
DATA A Sample,123 Sample Road,Sample Town,Sample County
DATA Mr Sample,123 Sample Road,Sample Town,Sample County
DATA Mr Alpha-Sample,123 Sample Road, Sample Town, Sample County
DATA Mr A    B    Sample,123  Sample  Road,Sample  Town,Sample  County

'*** Fill the record array and titlecase the fields ***

FOR Counter = 0 TO UBOUND(Record) - 1
        READ Record(Counter).Fullname
        TitleCase Record(Counter).Fullname
        READ Record(Counter).Add1
        TitleCase Record(Counter).Add1
        READ Record(Counter).Add2
        TitleCase Record(Counter).Add2
        READ Record(Counter).Add3
        TitleCase Record(Counter).Add3
NEXT Counter

'***  Define a simple titles array  ***
'***  Imagine how many other variations may be found  ***

DATA Mr,Miss,Mrs,Ms,Doctor,Dr
FOR Counter = 0 TO UBOUND(TitleComp$) - 1
        READ TitleComp$(Counter)
NEXT Counter

'*** Strip out any "odd" characters

FOR Counter = 0 TO UBOUND(Record) - 1
        Strip Record(Counter).Fullname
        Strip Record(Counter).Add1
        Strip Record(Counter).Add2
        Strip Record(Counter).Add3
NEXT Counter

'*** Split the fullname field into title, first inital and surname ***
'*** title first ***

FOR Counter = 0 TO UBOUND(Record) - 1
        Number = INSTR(Record(Counter).Fullname, " ")
        Text$ = LEFT$(Record(Counter).Fullname, Number - 1)
        FOR Count = 0 TO UBOUND(TitleComp$) - 1
                IF UCASE$(Text$) = UCASE$(TitleComp$(Count)) THEN
                        Record(Counter).Title = Text$
                        EndTitle = LEN(TitleComp$(Count)) + 2
                        EXIT FOR
                END IF
                EndTitle = 1
        NEXT Count
'*** To work out where the surname is we work backwards through the field
'*** The first space after the end spaces must be the start of the surname
       
        LastChar$ = " "
        FOR Count = LEN(Record(Counter).Fullname) TO 1 STEP -1
                LastChar$ = MID$(Record(Counter).Fullname, Count, 1)
                IF LastChar$ <> " " THEN
                        Number = Count
                        EXIT FOR
                END IF
        NEXT Count
        FOR Count = 1 TO Number
                CharPosn = INSTR(Count, Record(Counter).Fullname, " ")
                IF CharPosn >= Number THEN
                        Record(Counter).Surname = MID$(Record(Counter).Fullname, Count, LEN(Record(Counter).Fullname) - Count)
                        StartSur = Count
                        EXIT FOR
                END IF
        NEXT Count

'*** Get the initial
       
        IF EndTitle <> StartSur THEN
                Record(Counter).Initial = MID$(Record(Counter).Fullname, EndTitle, 1)
        END IF
NEXT Counter

'*** Create the "Contact" field
Text$ = ""
FOR Counter = 0 TO UBOUND(Record) - 1
        Text$ = RTRIM$(Record(Counter).Title) + " "
        IF Text$ = " " THEN
                Text$ = RTRIM$(Record(Counter).Initial) + " "
        ELSE
                Text$ = Text$ + RTRIM$(Record(Counter).Initial) + " "
        END IF
        Text$ = Text$ + RTRIM$(Record(Counter).Surname)
        Record(Counter).Contact = Text$
NEXT Counter

'*** Create the Salutation field
FOR Counter = 0 TO UBOUND(Record) - 1
        Text$ = "Dear " + Record(Counter).Title
        Text$ = RTRIM$(Text$) + " " + Record(Counter).Surname
        IF LEFT$(Record(Counter).Title, 1) = " " THEN
                Text$ = "Dear Sir/Madam"
        END IF
        Record(Counter).Salut = Text$
NEXT Counter

'***  Now the text is in sort of natural casing, create the matching fields

FOR Counter = 0 TO UBOUND(Record) - 1
        Record(Counter).MName = UCASE$(Record(Counter).Surname)
        Record(Counter).MAdd1 = UCASE$(Record(Counter).Add1)
        Record(Counter).MAdd2 = UCASE$(Record(Counter).Add2)
        Record(Counter).MAdd3 = UCASE$(Record(Counter).Add3)
NEXT Counter

'*** Process the matching fields
'*** This involves stripping spaces
FOR Counter = 0 TO UBOUND(Record) - 1
        MoreStrip Record(Counter).MName
        MoreStrip Record(Counter).MAdd1
        MoreStrip Record(Counter).MAdd2
        MoreStrip Record(Counter).MAdd3
NEXT Counter

PrintFlds

END

SUB MoreStrip (Text$)
NewText$ = ""
Count = 0
        FOR Counter = 1 TO LEN(Text$)
                Char$ = MID$(Text$, Counter, 1)
                IF INSTR("AEIOU ", UCASE$(Char$)) > 0 THEN
                        Char$ = ""
                        Count = Count + 1
                END IF
'*** For some reason commas need to be taken out specificaly
        IF Char$ = "," THEN
                Char$ = ""
                Count = Count + 1
        END IF
        NewText$ = NewText$ + Char$
NEXT Counter
Text$ = NewText$ + SPACE$(Count)
END SUB

SUB PrintFlds
CLS
FOR Count = 0 TO UBOUND(Record) - 1
        PRINT Record(Count).Title;
        PRINT Record(Count).Initial;
        PRINT Record(Count).Surname
        PRINT Record(Count).Fullname;
        PRINT Record(Count).Salut;
        PRINT Record(Count).Contact
        PRINT Record(Count).Add1;
        PRINT Record(Count).Add2;
        PRINT Record(Count).Add3
        PRINT Record(Count).MName;
        PRINT Record(Count).MAdd1;
        PRINT Record(Count).MAdd2;
        PRINT Record(Count).MAdd3
NEXT Count
END SUB

SUB Strip (Text$)
NewText$ = ""
Count = 0
FOR Counter = 1 TO LEN(Text$)
        Char$ = MID$(Text$, Counter, 1)
        IF INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYX 0123456789-", UCASE$(Char$)) < 1 THEN
                Char$ = ""
                Count = Count + 1
        END IF
        NewText$ = NewText$ + Char$
NEXT Counter
Text$ = NewText$ + SPACE$(Count)
END SUB

SUB TitleCase (Text$)

'*** This subroutine title cases text
'*** Split the text into words
'*** The initial letter of each word is uppercased
'*** The rest is lower cased
'*** While we're looking for spaces strip out extra ones

FinalText$ = ""
OldNum = 1
Number = 0
DO
        Number = INSTR(OldNum, Text$, " ")
        IF Number < 1 THEN EXIT DO
        NewText$ = MID$(Text$, OldNum, Number - OldNum)
        IF NewText$ > " " THEN
                FinalText$ = FinalText$ + UCASE$(LEFT$(NewText$, 1)) + LCASE$(MID$(NewText$, 2, Number - OldNum)) + SPACE$(1)
        END IF
        OldNum = Number + 1
LOOP UNTIL Number < 1

'*** Special case for hyphenated names
Number = INSTR(FinalText$, "-")
IF Number > 0 THEN
        MID$(FinalText$, Number + 1, 1) = UCASE$(MID$(FinalText$, Number + 1, 1))
END IF

Text$ = FinalText$
END SUB

